import { ResolvedFields, FieldsResolver, FieldResolver } from './field-resolver.js';
import { Merge, StrictlyPick } from './util.js';
export type Traits<Type extends Record<string, unknown>, TransientFields extends Record<string, unknown>> = {
    [traitName: string]: {
        defaultFields: FieldsResolver<Type & TransientFields>;
    };
};
export interface TypeFactoryDefineOptions<Type extends Record<string, unknown>, TransientFields extends Record<string, unknown>, _DefaultFieldsResolver extends FieldsResolver<Type & TransientFields>, _Traits extends Traits<Type, TransientFields>> {
    defaultFields: _DefaultFieldsResolver;
    traits?: _Traits;
}
export interface TypeFactoryInterface<Type extends Record<string, unknown>, TransientFields extends Record<string, unknown>, _DefaultFieldsResolver extends Partial<Record<keyof Type, FieldResolver<Type & TransientFields, unknown>>>, _Traits extends Traits<Type, TransientFields>> {
    build(): Promise<StrictlyPick<Merge<ResolvedFields<_DefaultFieldsResolver>, ResolvedFields<{}>>, keyof Type>>;
    build<T extends FieldsResolver<Type & TransientFields>>(inputFieldsResolver: T): Promise<StrictlyPick<Merge<ResolvedFields<_DefaultFieldsResolver>, ResolvedFields<T>>, keyof Type>>;
    buildList(count: number): Promise<StrictlyPick<Merge<ResolvedFields<_DefaultFieldsResolver>, ResolvedFields<{}>>, keyof Type>[]>;
    buildList<T extends FieldsResolver<Type & TransientFields>>(count: number, inputFieldsResolver: T): Promise<StrictlyPick<Merge<ResolvedFields<_DefaultFieldsResolver>, ResolvedFields<T>>, keyof Type>[]>;
    use<T extends keyof _Traits>(traitName: T): TypeFactoryInterface<Type, TransientFields, Merge<_DefaultFieldsResolver, _Traits[T]['defaultFields']>, _Traits>;
    resetSequence(): void;
}
export declare function defineTypeFactoryInternal<Type extends Record<string, unknown>, TransientFields extends Record<string, unknown>, _DefaultFieldsResolver extends FieldsResolver<Type & TransientFields>, _Traits extends Traits<Type, TransientFields>>(typeFieldNames: readonly (keyof Type)[], { defaultFields: defaultFieldsResolver, traits, }: TypeFactoryDefineOptions<Type, TransientFields, _DefaultFieldsResolver, _Traits>): TypeFactoryInterface<Type, TransientFields, _DefaultFieldsResolver, _Traits>;
//# sourceMappingURL=factory.d.ts.map