"use strict";
// MEMO: The tests for this module are covered by `e2e/*.e2e.ts`.
const code_generator_js_1 = require("./code-generator.js");
const config_js_1 = require("./config.js");
const schema_scanner_js_1 = require("./schema-scanner.js");
const plugin = {
    plugin(schema, _documents, config, _info) {
        (0, config_js_1.validateConfig)(config);
        const normalizedConfig = (0, config_js_1.normalizeConfig)(config);
        const typeInfos = (0, schema_scanner_js_1.getTypeInfos)(normalizedConfig, schema);
        const code = (0, code_generator_js_1.generateCode)(normalizedConfig, typeInfos);
        return code;
    },
};
module.exports = plugin;
//# sourceMappingURL=index.js.map